extern ref GetCollideData();

object Colliders;

#define USE_COLLISSION_DETECTION	1

#event_handler("CheckCollide","CheckCollide");

//Levis: Collider functions
void AddCollider(string building, int index, float x, float y, float z, float ay)
{
	if(!USE_COLLISSION_DETECTION) return;
	if(building == "") return;
	if (FindFile("PROGRAM/BUILDINGS/templates/", "*.c", building+".c") != "") 
	{
		if(LoadSegment("BUILDINGS/templates/"+building+".c"))
		{
			ref collidedata = GetCollideData();
			string idx = index;
			Colliders.checklist.(idx).building = building;
			aref Colliderdata; makearef(Colliderdata, Colliders.checklist.(idx));
			CopyAttributes(Colliderdata, collidedata);
			Colliders.checklist.(idx).building.x = x;
			Colliders.checklist.(idx).building.y = y;
			Colliders.checklist.(idx).building.z = z;
			Colliders.checklist.(idx).building.ay = ay;
			//Now let's transform the coords of the checkblocks
			aref Checks; makearef(Checks,Colliders.checklist.(idx).checks);
			int numcheck = GetAttributesNum(Checks);
			for(int n = 0; n < numcheck; n++)
			{
				aref check = GetAttributeN(Checks,n);
				check.y = stf(check.y) + y;
				float newx = x + (stf(check.x) * cos(ay) - stf(check.z) * sin(ay));
				float newz = z + (stf(check.x) * sin(ay) - stf(check.z) * cos(ay));
				check.x = newx;
				check.z = newz;
				check.ay = stf(check.ay) + ay;
				if(stf(check.ay) > PI) check.ay = stf(check.ay) - 2*PI;
				if(stf(check.ay) < (-1*PI)) check.ay = stf(check.ay) + 2*PI;
			}
			UnloadSegment("BUILDINGS/templates/"+building+".c");
		}
	}
}

void StartCollideCheck()
{
	int checktime = 10;
	aref CollideList; makearef(CollideList,Colliders.checklist);
	int numcheck = GetAttributesNum(CollideList);
	Colliders.numcheck = numcheck;
	int interval = checktime*numcheck;
	for(int n = 0; n < numcheck; n++)
	{
		int index = GetAttributeName(GetAttributeN(CollideList, n));
		SetEventHandler("CollideCheck"+index,"CollideCheck",1);
		PostEvent("CollideCheck"+index,(checktime*n),"ll",interval,index);
	}
}

void CollideCheck()
{
	int interval = GetEventData();
	int index = GetEventData();
	int radius = sti(Colliders.checklist.(index).checkradius);
	int num = FindNearCharacters(GetCharacter(index), radius, -1.0, -1.0, 0.001, false, true);
	ref findCh;
	for(int j = 0; j < num; j++)	// the following loop runs for each near character
	{
		int cidx = sti(chrFindNearCharacters[j].index);	// defines near character as idx
		if(cidx == index) continue;
		if(cidx < 0) continue;
		aref Checks; makearef(Checks,Colliders.checklist.(index).checks);
		int numcheck = GetAttributesNum(Checks);
		for(int n = 0; n < numcheck; n++)
		{
			PostEvent("CheckCollide",1,"lll",cidx,index,n);
		}
	}
	PostEvent("CollideCheck"+index,interval,"ll",interval,index);
}

void StopCollideCheck()
{
	aref CollideList; makearef(CollideList,Colliders.checklist);
	int numcheck = GetAttributesNum(CollideList);
	for(int n = 0; n < numcheck; n++)
	{
		int index = GetAttributeName(GetAttributeN(CollideList, n));
		DelEventHandler("CollideCheck"+index,"CollideCheck");
	}
	DeleteAttribute(&Colliders,"checklist");
	Colliders.numcheck = 0;
}

void CheckCollide()
{
	int charidx = GetEventData();
	int buildingidx = GetEventData();
	int numcheck = GetEventData();
	string check = "check"+numcheck;
	ref character = GetCharacter(charidx);
	if(GetAttribute(character,"chr_ai.type") == LAI_TYPE_BUILDING) return;
	
	float x,cx,y,cy,z,cz,ay,cay;
	GetCharacterPos(character, &x, &y, &z);
	GetCharacterAy(character, &ay);
	cx = stf(Colliders.checklist.(buildingidx).checks.(check).x);
	cy = stf(Colliders.checklist.(buildingidx).checks.(check).y);
	cz = stf(Colliders.checklist.(buildingidx).checks.(check).z);
	cay = stf(Colliders.checklist.(buildingidx).checks.(check).ay);
	
	switch(Colliders.checklist.(buildingidx).checks.(check).type)
	{
		case "circle":
			float distance = GetDistance2D(x, z, cx, cz);
			if(distance < sti(Colliders.checklist.(buildingidx).checks.(check).radius))
			{
				float angle = atan2((x-cx),(z-cz));
				float move = 0.1 * sti(Colliders.numcheck)*GetTimeScale();
				x = x + move*sin(angle);
				z = z + move*cos(angle);
				if(!IsMainCharacter(character)) ay = ay+0.25*pi; //to nudge npc's in another direction
			}
		break;
	}
	TeleportCharacterToPosAy(character, x, y, z, ay);
}
